欢迎来到PJCK的博客

(贪心) leetcode 452. Minimum Number of Arrows to Burst Balloons

There are a number of spherical balloons spread in two-dimensional space. For each balloon, provided input is the start and end coordinates of the horizontal diameter. Since it's horizontal, y-coordinates don't matter and hence the x-coordinates of start and end of the diameter suffice. Start is always smaller than end. There will be at most 104 balloons.

An arrow can be shot up exactly vertically from different points along the x-axis. A balloon with xstart and xend bursts by an arrow shot at x if xstart ≤ x ≤ xend. There is no limit to the number of arrows that can be shot. An arrow once shot keeps travelling up infinitely. The problem is to find the minimum number of arrows that must be shot to burst all balloons.

Example:

Input:
[[10,16], [2,8], [1,6], [7,12]]

Output:
2

Explanation:
One way is to shoot one arrow for example at x = 6 (bursting the balloons [2,8] and [1,6]) and another arrow at x = 11 (bursting the other two balloons).

-------------------------------------------------------------------------------------------------------------

这个题是贪心题,是区间选点问题。在排序C++的vector时,需要在外面用bool,并且要加上inline这个内联函数。还需要注意points是一个空数组的可能情况。

C++代码:

inline bool cmp(const vector<int> &a,const vector<int> &b){
    return a[1] < b[1];
}
class Solution {
public:
    
    int findMinArrowShots(vector<vector<int>>& points) {
        if(points.size() == 0)
            return 0;
        sort(points.begin(),points.end(),cmp);
        int sum = 1;
        int ans = points[0][1];
        for(int i = 1; i < points.size(); i++){
            if(ans < points[i][0]){
                sum++;
                ans = points[i][1];
            }
        }
        return sum;
    }
};

 

posted @ 2019-05-07 11:36  PJCK  阅读(137)  评论(0编辑  收藏  举报